<?php
Namespace App\Controller\Admin;

use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use App\Model\Admin\HomegearServiceMessage;

class LayoutController extends Controller
{
    public function header(Request $request, HomegearServiceMessage $messages)
    {
        $user = $this->getUser();
        return $this->render('Admin/header.html.twig', array(
            'locale' => $request->getSession()->get('_locale'),
            'currentUser' => $user->getUsername(),
            'serviceMessages' => $messages->list()
        ));
    }
    
    public function navigation($sect,$route)
    {
        $navigation = array();
        $routes = $this->get('router')->getRouteCollection();
        foreach ($routes as $key => $myRoute) {
            if (strpos($key, 'admin.') === 0) {
                if (array_key_exists('main_navigation',$myRoute->getDefaults()) && $myRoute->getDefaults()['main_navigation'] == 1) {
                    $defaults = $myRoute->getDefaults();
                    $navigation[$defaults['sect']] = ['name' => $defaults['name'], 'path' => $key, 'icon' => $defaults['icon'], 'sort' => $defaults['sort'], 'sect' => $defaults['sect'], 'target' => (array_key_exists('target',$defaults) ? $defaults['target'] : '')];
                }
                if (array_key_exists('sub_navigation',$myRoute->getDefaults()) && $myRoute->getDefaults()['sub_navigation'] == 1) {
                    $defaults = $myRoute->getDefaults();
                    $navigation[$defaults['sect']]['sub_navigation'][$defaults['sort']] = ['name' => $defaults['name'], 'path' => $key, 'icon' => $defaults['icon'], 'sect' => $defaults['sect'], 'target' => (array_key_exists('target',$defaults) ? $defaults['target'] : '')];
                }
            }
        }
        foreach ($navigation as $key => $value) {
            $navigation[$value['sort']] = $navigation[$key];
            unset($navigation[$key]);
            if (array_key_exists('sub_navigation',$navigation[$value['sort']])) {
                ksort($navigation[$value['sort']]['sub_navigation']);
            }
        }
        ksort($navigation);
        return $this->render('Admin/navigation.html.twig', array(
            'sect' => $sect,
            'route' => $route,
            'navigation' => $navigation
        ));
    }
}